/* ---------------------------------------------------
   Definition of classes in C++
   Definition of methods outside the class definition
   ---------------------------------------------------
*/

#include <iostream>
#include <cmath>
using namespace std;


float LineLen(float p1x, float p1y, float p2x, float p2y)
{
    return sqrt( pow((p1x-p2x),2)+pow((p1y-p2y),2) );
}



class line {    // *** Start of class declaration
public:          
     // Fields declaration
    float x1, y1, x2, y2;
    float len;
    // Methods declaration. Will be implemented outside the class.
    line(float px1, float py1, float px2, float py2);
    line(float px2, float py2);
    line(); 
    
    void show();
    void movex1(float newx1);
    

private:
    void linelen();

};             // *** End of class declaration

// *** definition of methods. notice the use of "class::" ***

    
void line::linelen() {          // Method to calculate the length
    // auto doulevei! : len=sqrt(pow((x1-x2),2)+pow((y1-y2),2));
    len=LineLen(x1,y1,x2,y2);
}
    
line::line(float px1, float py1, float px2, float py2) {    // Constructor 1
    x1=px1;
    y1=py1;
    x2=px2;
    y2=py2;
    linelen();
}
  
line::line(float px2, float py2) {  // Constructor 2
    x1=0;
    y1=0;
    x2=px2;
    y2=py2;
    linelen();
}

line::line() {    // Constructor 3
    cout<<endl<<"New line"<<endl;
    cout<<"X1:"; cin>>x1;
    cout<<"Y1:"; cin>>y1;
    cout<<"X2:"; cin>>x2;
    cout<<"Y2:"; cin>>y2;
    linelen();
}
    
void line::show() {
    cout<<"("<<x1<<", "<<y1<<") -> ("<<x2<<", "<<y2<<") :"<<len<<endl;
}

void line::movex1(float newx1) {
    x1=newx1;
    linelen();
}


int main()
{
    line l1(0,0,1,1);
    line l2(2,2);
    
    cout<<"Welcome to oo programming"<<endl;
    
    cout<<"Line 1 has length equal to "<<l1.len<<endl;
    
    cout<<"Line 2 has length equal to "<<l2.len<<endl;

    
    l1.show();
    
    l1.movex1(5);
    
    l1.show();

//    l2.show();
        
//    line l3;
//    cout<<"Line 3 has length equal to "<<l3.len<<endl;
    system("pause");
    return 0;
}   
