/* -------------------------------------------
   Definition of classes in C++
   Full example implemented with lines
   -------------------------------------------
*/
   

#include <iostream>
#include <cmath>
using namespace std;


class line {                    // *** Start of class declaration

public:                        // "private" means that members are NOT visible from outside    
    // Fields declaration
    float x1, y1, x2, y2;
    float len;

    // Method to calculate the length
    void linelen() {         
        len=sqrt(pow((x1-x2),2)+pow((y1-y2),2));
        TotalLength=TotalLength+len;
    }
    
    
//public:
    
    static float TotalLength;   // "static": shared by all objects of the class

    // Accessors: methods to return tha values of protected fields
    float X1() {
        return x1;
    }
    
    float X2() {
        return x2;
    }
    
    float Y1() {
        return y1;
    }
    
    float Y2() {
        return y2;
    }
    
    float LEN() {
        return len;
    }
        
    //Method to resize a line (move start point)
    void moveA(float newX1, float newY1)
    {
        x1=newX1;
        y1=newY1;
        linelen();
    }
    
    //Method to resize a line (move end point)
    void moveB(float newX2, float newY2)
    {
        x2=newX2;
        y2=newY2;
        linelen();
    }
    
    // Constructor 1: all four coordinates are given
    line(float px1, float py1, float px2, float py2) {
        x1=px1;
        y1=py1;
        x2=px2;
        y2=py2;
        linelen();
    }
    // Constructor 2: point 1 coordinates ASSUMED to be (0,0), 
    //                point 2 coordinates are given
    line(float px2, float py2) {
        x1=0;   
        y1=0;
        x2=px2;
        y2=py2;
        linelen();
    }
    // Constructor 3: No coordinates are given. 
    //                Will be read from the console
    line() {
        cout<<endl<<"New line"<<endl;
        cout<<"X1:"; cin>>x1;
        cout<<"Y1:"; cin>>y1;
        cout<<"X2:"; cin>>x2;
        cout<<"Y2:"; cin>>y2;
        linelen();
    }
}; // *** End of class declaration



float line::TotalLength = 0;

int main()
{

    cout<<"Welcome to oo programming"<<endl;
        
    line lin1(5,0,5,7);

    cout<<"Line 1 has length equal to "<<lin1.LEN()<<endl;
    cout<<"Total length so far:"<<line::TotalLength<<endl;

    line lin2(-2,0);
    cout<<"Line 2 has length equal to "<<lin2.LEN()<<endl;
    cout<<"Total length so far:"<<line::TotalLength<<endl;
    
    line lin3;
    cout<<"Line 3 has length equal to "<<lin3.LEN()<<endl;
    cout<<"Total length so far:"<<line::TotalLength<<endl;

    lin3.moveA(0,0);
    cout<<endl<<"Moved l3.A to (0,0)"<<endl;
    cout<<"Total length so far:"<<line::TotalLength<<endl;

    cout<<endl<<"Moved l2.B to (10,10)"<<endl;
    lin2.moveB(10,10);
    cout<<"Total length so far:"<<line::TotalLength<<endl;
    
    printf("\n\nThe coordinates of lin1 using direct access are : %f, %f\n\n",lin1.x1, lin1.y1);
    
    return 0;
}   

