#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

const int MAXK = 100;  


struct polygon {
  int K;
  float x[MAXK], y[MAXK];
  float Area, Perimeter;
  float Xin, Yin;
};


float linelen(float x1, float y1, float x2, float y2) {         
    return sqrt(pow((x1-x2),2)+pow((y1-y2),2));
}


class polygonclass {

public:
  int K;
  float x[MAXK], y[MAXK];
  float Area, Perimeter;
  float Xin, Yin;
  
  polygonclass(char *filename);
  void polygonprint();
  void calcperimeter();
//  void calcarea();
};

polygonclass::polygonclass(char *filename) {
    ifstream pfile(filename);
    int i=0;
    if (!pfile.is_open()) {
        cout<<"Could not open polygon.txt";
        exit(1); }
    
    pfile>>Xin>>Yin;
    while (!pfile.eof()) {
        pfile>>x[i];
        pfile>>y[i];
        i++; }
    K=i;
    pfile.close();
    
    calcperimeter();
}

void polygonclass::polygonprint() {
    int i;
    cout<<endl;
    for(i=0;i<K;i++) {
        cout<<i<<". \t"<<x[i]<<"\t"<<y[i]<<endl;
    }
    cout<<"Perimeter="<<Perimeter<<endl;
}
  
void polygonclass::calcperimeter() {
    float len, per=0;
    int i;
    for(i=0;i<K-1;i++) {
        len=linelen(x[i],y[i],x[i+1],y[i+1]);
        per=per+len;
    }
    per=per+linelen(x[0],y[0],x[K-1],y[K-1]);
            
    Perimeter=per;    
}
  
// ==========================================================


void init_polygon(polygon &p) {

    ifstream pfile("polygon.txt");
    int i=0;
    if (!pfile.is_open()) {
        cout<<"Could not open polygon.txt";
        exit(1); }
    
    pfile>>p.Xin>>p.Yin;
    while (!pfile.eof()) {
        pfile>>p.x[i];
        pfile>>p.y[i];
        i++; }
    p.K=i;
    pfile.close();
}

void polygon_data(polygon p) {
    int i;
    for(i=0;i<p.K;i++) {
        cout<<i<<". \t"<<p.x[i]<<"\t"<<p.y[i]<<endl;
    }
}

int main() {
    
    // using structure
    polygon x;
    init_polygon(x);
    polygon_data(x);
    
    // using class
    cout<<endl<<"USING CLASSES"<<endl;
    
    polygonclass y("polygon.txt");
    y.calcperimeter();
    y.polygonprint();
    
    
    system("pause");
}



        
        
        
        
        
        
        
        
        
        
